import QtQuick 2.9
import QtMultimedia 5.8
import QtQuick.Window 2.2
import QtQuick.Controls 2.2
import QtQuick.Layouts 1.3
import QtGraphicalEffects 1.0
import QtQuick.Controls.Styles 1.4

import de.itsblue.ScStw 2.0
import de.itsblue.ScStw.Styling 2.0
import de.itsblue.ScStw.Styling.Components 1.0
import de.itsblue.ScStwApp 2.0

import "../components"

Column {
    id: control

    property string title: qsTr("options")

    property var parentObj

    spacing: parent.rowSpacing

    /*----Connect to external devices----*/
    NextPageDelegate {
        id: connect_del

        height: parentObj.delegateHeight

        text: qsTr("base station")
        onClicked: {
            parentObj.push(connect)
        }
    }

    /*----Automated Start----*/
    NextPageDelegate {
        id: autostart_del

        height: parentObj.delegateHeight

        text: qsTr("start sequence")

        onClicked: {
            parentObj.push(autostart)
        }
    }

    /*----Style Settings----*/
    SmoothSwitchDelegate {
        id: styleDel
        text: qsTr("dark mode")

        width: parent.width
        height: parentObj.delegateHeight

        checked: appTheme.setting === "Dark"

        onCheckedChanged: {
            appThemeSetting.value = checked ? "Dark":"Light"
        }
    }
}
